Echo off
rem  This is an example of a BAT to use in one of Intellicomm's external
rem  protocol entries.  It is set up for a Zmodem receive using the DSZ
rem  external protocol program, by Chuck Forsberg (Shareware, available on
rem  most BBS's).  This is an EXAMPLE ONLY and may or may not work with your
rem  modem.  If you have problems please refer to the DSZ documentation.
rem
rem  TIP:  If you prefer using DSZ Zmodem rather than Intellicomm's internal
rem  Zmodem, you should consider changing the 'Auto-Zmodem Protocol' to this
rem  external protocol.  This way Icom will automatically call DSZ-Zmodem 
rem  rather than using its internal Zmodem when an auto-Zmodem download is
rem  detected.  See the Intellicomm Main Setup/File screen and select the
rem  Auto-Zmodem protocol item if you don't understand.  You may tell Icom
rem  to run ANY protocol when an auto-Zmodem download is detected.
rem
rem  Parameters Passed from Intellicomm:
rem
rem   %1=baud %2=port %3=-CDSlog %4=fspec [or @d:list if File Picker was used]
rem
rem  The -CDS switch points to Intellicomm's Call Data Standard format
rem  Usage Log, if the Log is open when this BAT is called.  Any program
rem  that follows the CDS standard can stamp Icom's Log to keep your records
rem  in the same place, and in the same format.  In this way Log files can
rem  be analyzed by Usage Log analyzers that understand the CDS standard, and
rem  external file transfers will be accounted for in the report.
rem  The -CDS switch is specified in the Call Data Standard, so any program
rem  that follows the standard will be expecting it on its own command
rem  line.  Just use %3 to pass it.
rem
rem  *NOTE:*  You -must- have DSZ place files in your Icom Download Directory
rem  (defined in the Intellicomm Main Setup) during automated downloads, or it
rem  will think the transfer was unsuccessful and will attempt to download the
rem  same files after the transfer completes.  The CD \ICOM\GET below should
rem  either be changed to the proper directory (if evaluating DSZ) or you
rem  should add your download directory to the END of the DSZ line below
rem  after the -mrr switch... specify the FULL path C:\ICOM\GET, etc.
rem
rem  If DSZ is not on your DOS PATH you must precede the DSZ command with
rem  the proper pathname.  E.g.  C:\UTIL\DSZ port ...
rem
cd \ICOM\GET
DSZ port %2 speed %1 ha on rz -mrr
cd..
